
%MACRO copy_ext_files(dir_in=,dir_out=
                                        ,file_list_in=, file_list_out=
                                        ,device_type_in=DISK, device_type_out=DISK
                                        ,host_options_in=, host_options_out=
									    ,tbl_name_with_files_info=
                                        );

 /*	  Usage:

%LET dir_in=&infolder.;
%LET dir_out=&infolder_dp1;
%LET file_list_in=test.sas7bdat vars_nm_value_pairs.sas7bdat dr2_i1_model_coeff.sas7bdat;
%LET file_list_out=;
%LET device_type_in=DISK;
%LET device_type_out=DISK;
 %LET host_options_in=%STR(RECFM=N); * Default binary copy . 
 *%LET host_options_out=%STR(RECFM=N);
 %LET tbl_name_with_files_info=;

 * %LET tbl_name_with_files_info=infolder.tbl_name_with_files_info;

		  %copy_ext_files(dir_in=&infolder.
										,dir_out=&infolder_dp1.
                                        ,file_list_in=&file_list_in.
                                        );

 * OPTION RECFM=N is invalid in the FTP context. Use BINARY or RECFM=F instead ;

 %LET host_options_out=%STR(host="wizard" user="&user_wizard" password="&password_wizard." BINARY);

       %copy_ext_files(dir_in=&infolder.
                                ,file_list_in=&file_list_in.
							   ,dir_out=./reports/
								,device_type_out=FTP
								,host_options_out=&host_options_out.
                                );

 Table tbl_name_with_files_info has to have the same variables  names as as other parm
	in this macro. When tbl_name_with_files_info is specified then other macro parameters 
	in this macro  are ignored.

%copy_ext_files( tbl_name_with_files_info=infolder.tbl_name_with_files_info );

   */

	  %GLOBAL m_return_cd  DEBUG_FLAG2 ;	
      %LOCAL _DEBUG_OPTIONS_L ;
   
 %LET _DEBUG_OPTIONS_L=%sysfunc(getoption(symbolgen)) %sysfunc(getoption(mprint)) %sysfunc(getoption(mlogic)) %sysfunc(getoption(notes)) %sysfunc(getoption(source)) %sysfunc(getoption(source2));
 %IF &DEBUG_FLAG2. NE Y %THEN %DO;OPTIONS NOMLOGIC NOMPRINT NOSYMBOLGEN  NOSOURCE NOSOURCE2; %END;

  %PUT;
   %PUT -----   Start of the macro copy_ext_files. ;
   %PUT;

   %LET m_return_cd=0;

		   %LOCAL set_tbl_name_with_files_info;

	 %IF  %LENGTH(&tbl_name_with_files_info.) >0 
    %THEN %LET  set_tbl_name_with_files_info=%STR(SET &tbl_name_with_files_info.;);
	%ELSE %LET set_tbl_name_with_files_info=;									               
 
	OPTIONS NOTES;

DATA _NULL_;

   LENGTH dir_in dir_out 
                   file_list_in file_list_out 
                   full_file_name_in full_file_name_out 
 				   file_nm_in file_nm_out  
                   device_type_in  device_type_out
                   host_options_in  host_options_out 
                   tmp_file_nm_out $ 5000
                   Message_fcopy Message $  1000  ;

	 ARRAY dir_nm{*} dir_in dir_out ;
	 ARRAY  full_f_nm{*}  full_file_name_in  full_file_name_out ;
	 ARRAY file_list{*}  file_list_in  file_list_out ;
	 ARRAY  file_nm{*}  file_nm_in  file_nm_out ;
	 ARRAY  device_type{*}  device_type_in  device_type_out ;
	  ARRAY  host_options{*}  host_options_in  host_options_out ;
	  ARRAY  fref{2} $  fref_in fref_out  ("_tmp1" "_tmp2")	;

			   &set_tbl_name_with_files_info.;
   
   
		 DO i_d=1 TO 2;
						   rc=0;
	        IF  %LENGTH(&tbl_name_with_files_info.) =0 THEN
										 DO;
			   dir_nm{i_d}=STRIP(SYMGET(VNAME(dir_nm{i_d}) ) );
			   file_list{i_d}=STRIP(SYMGET(VNAME(file_list{i_d}) ) );
			  device_type{i_d}=STRIP(SYMGET(VNAME(device_type{i_d}) ) );
			  host_options{i_d}=STRIP(SYMGET(VNAME(host_options{i_d}) ) );
			   							END;
			
						/*Set defaults."RECFM=N" implies binary copy  */
			   device_type{i_d}=COALESCEC(device_type{i_d},"DISK");
			   host_options{i_d}=COALESCEC(host_options{i_d},"RECFM=N");

				   IF  dir_nm{i_d} NE " " THEN
						  DO;
			  	/* Translate possible WIN slash to UNIX slash. 
					The later is interpreted by SAS correctly on all OS including WIN. */
			    dir_nm{i_d}=TRANSLATE(STRIP( dir_nm{i_d}),"/","\");

									 /*Remove quotes from  dir_nm{i_d} if present */

			   IF         SUBSTR( dir_nm{i_d},1,1)=SUBSTR( dir_nm{i_d},LENGTH( dir_nm{i_d}),LENGTH( dir_nm{i_d})) 
		        AND SUBSTR( dir_nm{i_d},1,1) IN ("'",'"') 
			THEN  dir_nm{i_d}=SUBSTR( dir_nm{i_d},2,LENGTH( dir_nm{i_d})-2);

						  /* Add slash at the end  dir_nm{i_d} if necessary */

		   	 IF        SUBSTR( dir_nm{i_d},LENGTH( dir_nm{i_d}),LENGTH( dir_nm{i_d})) NOT IN ("/","\")
				AND  dir_nm{i_d} NE " "
			THEN  dir_nm{i_d}=CATS( dir_nm{i_d},"/");

		IF UPCASE(device_type{i_d})="DISK"	THEN  rc=( FILEEXIST(STRIP(dir_nm{i_d})) NE 1 );

			   IF  rc NE 0 THEN GO TO  end_ds;
																
			    IF i_d=1 THEN PUT;
				PUT dir_nm{i_d}=;
				IF i_d=2 THEN PUT;

						   END;	/* End of do-group dir_nm{i_d} NE " "*/

		 END;	/* End of intitialization do-loop   i_d=1 TO 2 */
	  
		  files_count=COUNTW(STRIP(file_list_in), " ");

     DO i_f=1 TO files_count;

					   rc=0;
		DO i_d=1 TO 2;

				file_nm{i_d}=SCAN(file_list{i_d},i_f, " ");	
	
		    IF i_d=2 AND  file_nm{i_d}=" "  THEN file_nm{i_d}=file_nm_in;

				  /*Remove quotes from file_nm if present*/

			IF         SUBSTR(file_nm{i_d},1,1)=SUBSTR(file_nm{i_d},LENGTH(file_nm{i_d}),LENGTH(file_nm{i_d})) 
		        AND SUBSTR(file_nm{i_d},1,1) IN ("'",'"') 
			THEN  file_nm{i_d}=SUBSTR(file_nm{i_d},2,LENGTH(file_nm{i_d})-2);

            full_f_nm{i_d}=CATS(dir_nm{i_d},file_nm{i_d});

rc_fref=FILENAME(fref{i_d}, STRIP(full_f_nm{i_d}),STRIP(device_type{i_d}) ,STRIP(host_options{i_d}) );

			  rc=(rc_fref NE 0);

			 	IF rc NE 0 THEN GO TO  end_ds; 

  	IF  i_d=1 AND UPCASE(device_type{i_d})="DISK"	THEN  rc=( FILEEXIST(STRIP(full_f_nm{i_d} ) ) NE 1 );
								
				IF i_d=1 AND rc NE 0 THEN GO TO  end_ds; 
 
 			END;	 /* End of do-loop i_d=1 TO 2*/

			    rc_fcopy=FCOPY(fref_in, fref_out);
				rc=MAX(rc,(rc_fcopy NE 0));
				IF rc_fcopy=0 THEN 
									  DO;
				  IF  file_list_out=" "  THEN  tmp_file_nm_out=" ";
				  ELSE 								 tmp_file_nm_out=CATX(" ", "to",file_nm_out);

                    Message_fcopy= CATX(" ", "File",file_nm_in, "has been copied",tmp_file_nm_out);
									 END;
				ELSE 
				 				   DO;
                         Message_fcopy=SYSMSG();
				    IF 	Message=" " THEN Message=Message_fcopy;
								  END;

				PUT Message_fcopy;

				   rc_fref_clear=FILENAME(fref_in);
				   rc_fref_clear=FILENAME(fref_out);

    END;  /* End of  do-loop over files i_f=1 TO files_count */

  end_ds:

   IF  rc NE 0 THEN
                                  DO;
					 PUT   rc=;
		IF 	Message=" "	 THEN	 Message=SYSMSG();
	                  PUT  Message=;					  
				                 END;
	CALL SYMPUT("m_return_cd",STRIP(PUT(rc,8.)) );
/* PUT _ALL_;	*/
 RUN;

  %PUT;
   %PUT -----   End of the macro copy_ext_files. ;
   %PUT;

   	 OPTIONS &_DEBUG_OPTIONS_L.;
%MEND;

 


 
 



 