
 %MACRO copy_sas_tables(lib_in=,lib_out=, dir_in=, dir_out=,tbl_list_in=,tbl_list_out=);
	/*
	  Usage:

	%LET lib_in=infolder;
	 %LET dir_in=&infolder.;
	%LET dir_out=&infolder_dp1.;
	%LET tbl_list_in=vars_nm_value_pairs dr2_i1_model_coeff;
    %LET tbl_list_out=vars_nm_value_pairs_t dr2_i1_model_coeff;

			*	Copy all tables. Specify both directories: ;
	 %copy_sas_tables(dir_in=&dir_in. , dir_out=&dir_out.);

				* Copy list of tables: ;
	 %copy_sas_tables(dir_in=&dir_in. , dir_out=&dir_out., tbl_list_in=&tbl_list_in.);

 	 *  Copy list of tables. Specify out directory and libref for lib_in. ;
              * When libref lib_in is specified dir_in is ignored :

			   %copy_sas_tables(lib_in=infolder , dir_out=&dir_out. , tbl_list_in=&tbl_list_in.);

*	Copy list of tables and rename first table to vars_nm_value_pairs_t :  ;
       	 %copy_sas_tables(dir_in=&dir_in. 
                                        , dir_out=&dir_out.
                                         ,tbl_list_in=vars_nm_value_pairs dr2_i1_model_coeff
                                         ,tbl_list_out=vars_nm_value_pairs_t ); 
 
	*/
 %GLOBAL m_return_cd  DEBUG_FLAG2 ;	
  %LOCAL _DEBUG_OPTIONS_L  ;

 %LET _DEBUG_OPTIONS_L=%sysfunc(getoption(symbolgen)) %sysfunc(getoption(mprint)) %sysfunc(getoption(mlogic)) %sysfunc(getoption(notes)) %sysfunc(getoption(source)) %sysfunc(getoption(source2));
 %IF &DEBUG_FLAG2. NE Y %THEN %DO;OPTIONS NOMLOGIC NOMPRINT NOSYMBOLGEN  NOSOURCE NOSOURCE2; %END;

 %LOCAL change_names;

  %PUT;
   %PUT -----   Start of the macro copy_sas_tables. ;
   %PUT;

   %LET m_return_cd=0;

 %IF %LENGTH(&lib_in.)=0 %THEN 
                     %DO; 
      %LET lib_in=_CP_IN; LIBNAME _CP_IN "&dir_in.";
	                   %END;

  %IF %LENGTH(&lib_out.)=0 %THEN 
                     %DO; 
      %LET lib_out=_CP_OUT; LIBNAME _CP_OUT "&dir_out.";
	                   %END;

%IF %LENGTH(&tbl_list_out.) >0 %THEN
                    %DO;  
     DATA  _NULL_;
      LENGTH tbl_list_in tbl_list_out change_names $ 5000 tbl_name_in tbl_name_out $ 32;
         RETAIN change_names;
      
	   tbl_list_in=STRIP(SYMGET("tbl_list_in"));
	   tbl_list_out=STRIP(SYMGET("tbl_list_out"));

	   tbls_count=COUNTW(STRIP(tbl_list_in), " ");

	     DO i_t=1 TO tbls_count;
					
			   tbl_name_in=SCAN(tbl_list_in,i_t, " ");	
			   tbl_name_out=SCAN(tbl_list_out,i_t, " ");

		    IF        TRIM(tbl_name_out) NE " "
               AND STRIP(UPCASE(tbl_name_in)) NE STRIP(UPCASE(tbl_name_out)) 

        THEN   change_names=STRIP(change_names) ||  " " || STRIP(tbl_name_in) 
                                                  || "=" ||  STRIP(tbl_name_out) ;
						
		 END;  /*End of i_t=1 TO tbls_count; */

            CALL SYMPUT ('change_names',change_names) ;
   RUN;

   %PUT change_names=&change_names.;
					  	%END;

   %IF %LENGTH(&tbl_list_in.) >0           %THEN %LET tbl_list_in=SELECT &tbl_list_in.;
   %IF %LENGTH(&tbl_list_out.) >0         %THEN %LET tbl_list_out=DELETE &tbl_list_out.;
    %IF %LENGTH(&change_names.) >0 %THEN %LET change_names=CHANGE &change_names.;

	OPTIONS NOTES;

  PROC DATASETS LIB=&lib_out. NOLIST NOWARN;
	     &tbl_list_out.;
	   COPY IN=&lib_in. OUT=&lib_out.;
	    &tbl_list_in.;
       &change_names.;
  RUN;
   QUIT;

	%LET m_return_cd=&SYSERR.;

%IF %LENGTH(&lib_in.)=0 %THEN	 LIBNAME  _CP_IN    CLEAR;
%IF %LENGTH(&lib_out.)=0 %THEN	 LIBNAME  _CP_OUT CLEAR;

   %PUT m_return_cd=&m_return_cd.;
   
  %PUT;
   %PUT -----   End of the macro copy_sas_tables. ;
   %PUT;

	 OPTIONS &_DEBUG_OPTIONS_L.;
 %MEND;

