
%MACRO create_lreg_rpt( lib_in=msoc, rpt_dir_out=./,prefix_r=,title1="Linear Regression");

/*
 %LET lib_in=dplocal;
 %LET rpt_dir_out=&dplocal.;
 %LET prefix_r=c1_;
 %LET title1="Linear Regression";
*/
 /*
 %LET lib_in=msoc;
 %LET rpt_dir_out=&msoc.;
 %LET prefix_r=r1_;
 %LET title1="Linear Distributed Regression";
  */

     OPTIONS DEVICE=PNG;

 ODS PDF FILE="&rpt_dir_out.&prefix_r.Regression_rpt.pdf" ;

     *OPTIONS ORIENTATION=LANDSCAPE;
	 OPTIONS ORIENTATION=PORTRAIT;
		OPTIONS MISSING=" ";	  
	  TITLE1 &title1;
	  TITLE2 "Analysis of Variance";
	  TITLE3 "Dependent Variable: #BYVAL(Dependent)"	;
	  	OPTIONS NOBYLINE ;
	
       PROC PRINT DATA=&lib_in..&prefix_r.ANOVA(DROP=MODEL)  Noobs LABEL;
	    BY 	Dependent;
	    LABEL SS="Sum of Squares"               
	                 MS="Mean Square"
	                 FValue="F Value"
	                 ProbF="Pr > F"
				;
	   RUN;	   
	  TITLE3;
	 	OPTIONS BYLINE ;
 	
	  DATA 	 &prefix_r.FitStatistics_rp1(KEEP=Label1 nValue1  RENAME=(Label1=Statistic nValue1 =Value))
				  &prefix_r.FitStatistics_rp2(KEEP=Label2 nValue2  RENAME=(Label2=Statistic nValue2 =Value))
                    ;
	    SET &lib_in..&prefix_r.FitStatistics(DROP=MODEL Dependent cValue1 cValue2);
		
		    IF Label1 NE " " THEN OUTPUT &prefix_r.FitStatistics_rp1;
		    IF Label2 NE " " THEN OUTPUT &prefix_r.FitStatistics_rp2;
	 RUN;
	  
  PROC TRANSPOSE DATA=&lib_in..&prefix_r.model_coeff(KEEP=_AIC_ _BIC_ _SBC_) 
                                        OUT=&prefix_r.FitStatistics_rp3(RENAME=(_LABEL_=Statistic COL1=Value));

  RUN;

  DATA 	 &prefix_r.FitStatistics_rp4;
  LENGTH Statistic $ 50;
    SET  &prefix_r.FitStatistics_rp1 &prefix_r.FitStatistics_rp2 &prefix_r.FitStatistics_rp3(IN=in3);
	IF in3 THEN Statistic=CATX(" ",_NAME_,Statistic);
	KEEP  Statistic Value;
 RUN;
 
		TITLE2 "Fit Statistics";
	    PROC PRINT DATA=&prefix_r.FitStatistics_rp4 Noobs ;
		 VAR Statistic Value;
		RUN;


		  TITLE2             "Parameter Estimates";
		  FOOTNOTE1 "HCC Approximation Method: HC1" ;

	    PROC PRINT DATA=&lib_in..&prefix_r.P_EST_HC Noobs LABEL;
		VAR Variable DF Estimate StdErr tValue Probt LowerCL UpperCL HCStdErr HCCMethod HCTValue 
				HCProbt HCLowerCL HCUpperCL 
				;
		RUN;

		 TITLE2 ;
		 FOOTNOTE1 ;

		TITLE2 "Collinearity Diagnostics";
	    TITLE3 "Possible collinearity: for high condition index (>10) two variance proportion values greater than 0.5. ";
	    PROC PRINT DATA=&lib_in..&prefix_r.CollinDiag(DROP=MODEL 	Dependent) Noobs LABEL;
		RUN;
		TITLE2 ;
	    TITLE3 ;

		 	TITLE2 "Covariance of Estimates";

	    PROC PRINT DATA=&lib_in..&prefix_r.COV_EST(DROP=Model Dependent ) Noobs LABEL;
		RUN;
		TITLE2 ;
	    TITLE3 ;

		 	TITLE2 "Heteroscedasticity Consistent Covariance of Estimates";

	    PROC PRINT DATA=&lib_in..&prefix_r.HC_COV(DROP=Model Dependent ) Noobs LABEL;
		RUN;
		TITLE2 ;
	    TITLE3 ;

		 ODS PDF CLOSE;

	%MEND;	


	







	



	      