
 %MACRO mv_files_between_central_dp(dp_cd_list=1 2 3, max_run_time_in_sec=6);

  /*  Usage:
	   OPTIONS MSGLEVEL=N;	 
    %mv_files_between_central_dp(dp_cd_list=1 2 3, max_run_time_in_sec=6 );

  */
 
%LOCAL _DEBUG_OPTIONS_L ;
 %LET _DEBUG_OPTIONS_L=%sysfunc(getoption(symbolgen)) %sysfunc(getoption(mprint)) %sysfunc(getoption(mlogic)) %sysfunc(getoption(notes)) %sysfunc(getoption(source)) %sysfunc(getoption(source2));	
 %IF &DEBUG_FLAG2. NE Y %THEN %DO;OPTIONS NOMLOGIC NOMPRINT NOSYMBOLGEN NONOTES NOSOURCE NOSOURCE2; %END;


	  %LOCAL send_receive_cd dp_cd i  count_dp  dir_in dir_out 
                     file_list_in tbl_list_in rc_files_done_ok_exist 
                      start_time run_time_in_sec time_exceeded_flag done iter_nb 
					  cp_sas_return_cd rc_read_file_list_csv
                     ;

	   %LET start_time=%SYSFUNC(DATETIME()); 

	   %delete_ext_file(file_name=&infolder.job_done.ok, warning_flag=0);
	   %delete_ext_file(file_name=&infolder.job_fail.ok, warning_flag=0);

	 %LET rc_job_done_ok_exist=0;
	 %LET rc_job_fail_ok_exist=0;
	 %LET done=0;
	 %LET iter_nb=0;
	 %LET rc_read_file_list_csv=0;

    %LET   count_dp=%SYSFUNC(COUNTW(&DP_CD_List.));

   %DO %UNTIL(&done.=1 );
		 
			%DO send_receive_cd=1 %TO 2;
				   %IF &send_receive_cd.=1 %THEN
							    %DO;
		   %LET dir_in=&infolder.;
		   %LET rc_files_done_ok_exist=%SYSFUNC(FILEEXIST("&dir_in.files_done.ok"));
		  	%IF &rc_files_done_ok_exist.=0  %THEN  %GOTO endsrlp;

				%LET iter_nb=%EVAL(&iter_nb. + 1);
							     %END;
                         
			   %DO i=1 %TO &count_dp.;
					   %LET dp_cd=%SCAN(&dp_cd_list.,&i.);

					   %IF &send_receive_cd.=1 %THEN
					                   %DO;
							%LET dir_out=&&&infolder_dp&dp_cd.;
							           %END;
						%ELSE
						                  %DO;
						    %LET dir_in=&&&msoc_dp&dp_cd.;
							%LET dir_out=&&msoc&dp_cd.;

  %LET rc_files_done_ok_exist=%SYSFUNC(FILEEXIST("&dir_in.files_done.ok"));
   %IF &rc_files_done_ok_exist.=0 %THEN  %GOTO enddplp; 
							           %END;

		
		%IF (     (&send_receive_cd.=1  AND  &i.= 1) OR  &send_receive_cd.=2 ) %THEN
					       %DO;
				 %LET file_list_in=;
			      %LET tbl_list_in=;

			PROC DATASETS NOLIST NOWARN;
				DELETE  file_list_tmp;
		     RUN;

			 	%LET rc_read_file_list_csv=0;

		%import_dlm_txt_to_sas(file_name_in=&dir_in.file_list.csv
		                                           ,tbl_name_out=file_list_tmp
												    )	;
			%LET rc_read_file_list_csv=&m_return_cd.;										 

		  PROC SQL NOPRINT;
		    SELECT STRIP(file_nm) INTO :tbl_list_in SEPARATED BY " "
		         FROM  file_list_tmp
				  WHERE transfer_to_site_in=1
				     AND INDEX(file_nm,".sas7bdat") >0
				  ;
			QUIT;

			  PROC SQL NOPRINT;
		    SELECT STRIP(file_nm) INTO :file_list_in SEPARATED BY " "
		         FROM  file_list_tmp
				  WHERE transfer_to_site_in=1
				     AND INDEX(file_nm,".sas7bdat") =0
				  ;
			QUIT;

		  %LET tbl_list_in=%SYSFUNC(TRANSTRN(&tbl_list_in., .sas7bdat,));

		  	         %END;  /* End of do-group ( (&send_receive_cd.=1  AND  &i.= 1) OR  &send_receive_cd.=2 ) */
 
		  					%PUT;
							 %PUT iter_nb=&iter_nb.;
							%PUT send_receive_cd=&send_receive_cd.;
							%PUT dp_cd=&dp_cd.;
							%PUT tbl_list_in=&tbl_list_in.;
							%PUT file_list_in=&file_list_in.;
							%PUT rc_read_file_list_csv=&rc_read_file_list_csv.;
					/*		%PUT dir_in=&dir_in.;
						   	%PUT dir_out=&dir_out.; 		*/
							%PUT;
 
			 %IF &rc_read_file_list_csv. NE 0  %THEN  %GOTO endsrlp;

		  	 %LET  cp_sas_return_cd=0;
			  %LET cp_files_return_cd=0;

		       %IF %LENGTH(&tbl_list_in.) >0  %THEN
			                                 %DO;
		  %copy_sas_tables(dir_in=&dir_in. , dir_out=&dir_out., tbl_list_in=&tbl_list_in.);
					  %LET 	cp_sas_return_cd=&m_return_cd.;
					  %PUT cp_sas_return_cd=&cp_sas_return_cd.;
		                                      %END;

		  %IF %LENGTH(&file_list_in.) >0  %THEN
			                                 %DO;
		  %copy_ext_files(dir_in=&dir_in. , dir_out=&dir_out., file_list_in=&file_list_in.);
		                     %LET cp_files_return_cd=&m_return_cd.;
							 %PUT cp_files_return_cd=&cp_files_return_cd.;
		                                      %END;

			       %IF &cp_sas_return_cd. =0 AND &cp_files_return_cd.=0 	%THEN
			                                 							%DO;
						%create_empty_file(file_nm=&dir_out.files_done.ok);
																		%END;
											  

		%IF ((&send_receive_cd.=1  AND  &i.= &count_dp.) OR  &send_receive_cd.=2 ) %THEN
					                       %DO;
		  %delete_ext_file(file_name=&dir_in.files_done.ok, warning_flag=0); 
											%END;   
		  	  %enddplp:
				                %END; /* End of DPs do-loop i=1 TO &count_dp.*/

			 %endsrlp:
			     %END; /* End of  do-loop send_receive_cd=1 %TO 2; */

	
			 %file_watcher(file_name=&infolder.job_done.ok	 
				 					 ,wait_time_min=0.001
									 ,wait_time_max=0.01
									  ,silent_flag=1
								      );
		 
		  %LET rc_job_done_ok_exist=&_fileexist_flag.;
		  %LET rc_job_fail_ok_exist=%SYSFUNC(FILEEXIST("&infolder.job_fail.ok"));

	 %LET run_time_in_sec=%SYSEVALF(%SYSFUNC(DATETIME()) - &start_time.);
	  %LET time_exceeded_flag=%SYSEVALF((&run_time_in_sec.  - &max_run_time_in_sec.) > 0, BOOLEAN );

		  %IF  &time_exceeded_flag.  > 0
			   OR &rc_job_done_ok_exist.
			   OR &rc_job_fail_ok_exist.
			   OR &rc_read_file_list_csv. NE 0
		  %THEN   %LET done=1;

   %END;  /* End of  do-until loop   */

			   %PUT iter_nb=&iter_nb.;
			  %PUT time_exceeded_flag=&time_exceeded_flag.;
			   %PUT  rc_job_done_ok_exist=&rc_job_done_ok_exist.;
			   %PUT  rc_job_fail_ok_exist=&rc_job_fail_ok_exist.;
			   %PUT  rc_read_file_list_csv=&rc_read_file_list_csv.;
			   %PUT  run_time_in_sec=&run_time_in_sec.;
			   %PUT max_run_time_in_sec=&max_run_time_in_sec.;
			   	%PUT;
				  OPTIONS &_DEBUG_OPTIONS_L.;
  %MEND;

   /*  Usage:
	   OPTIONS MSGLEVEL=N;	 
    %mv_files_between_central_dp(dp_cd_list=1 2 3, max_run_time_in_sec=10);

  */