/*																	   
*  %LET tbl_list_to_transf=vars_nm_value_pairs.sas7bdat &prefix.model_coeff.sas7bdat  &RunID._track_tbl.sas7bdat &RunID._track_tbl_fl_lev.sas7bdat;
%LET tbl_list_to_transf= &prefix.model_coeff.sas7bdat  &RunID._track_tbl.sas7bdat &RunID._track_tbl_fl_lev.sas7bdat;

  %LET tbl_list_not_transf=&RunID._track_tbl.csv vars_nm_value_pairs_for_client.csv  file_list.csv ;
  * %LET tbl_list_not_transf=;

    %LET file_list_txt_out=&infolder_dir.file_list.csv;
	%LET file_list_txt_out=;
*  %LET file_list_tbl_out=&prefix2.file_list;

  %LET dir_nm="&infolder_dir."	;
   */

  %MACRO output_file_list(tbl_list_to_transf=
										    ,tbl_list_not_transf=
										    ,file_list_txt_out=
											,file_list_tbl_out=
											,file_list_tbl_out_for_csv=_file_list
										    ,send_received_cd=1
											,dir_nm=);

	/* Ver 2. After 20170130 (modification for job_done.ok job_fail) .*/

%GLOBAL m_return_cd  DEBUG_FLAG2 ;	

%LOCAL _DEBUG_OPTIONS_L ;
 %LET _DEBUG_OPTIONS_L=%sysfunc(getoption(symbolgen)) %sysfunc(getoption(mprint)) %sysfunc(getoption(mlogic)) %sysfunc(getoption(notes)) %sysfunc(getoption(source)) %sysfunc(getoption(source2));	
 %IF &DEBUG_FLAG2. NE Y %THEN %DO;OPTIONS NOMLOGIC NOMPRINT NOSYMBOLGEN  NOSOURCE NOSOURCE2; %END;

  %PUT;
   %PUT -----   Start of the macro output_file_list;
   %PUT;

     PROC DATASETS NOLIST NOWARN  ;
	   DELETE   _file_list_tbl_out;
	   RUN;
	  QUIT;

	    DATA  _file_list_tbl_out;
		 LENGTH tbl_name $ 32 ext $ 10 file_nm $ 50  tmp_str $  32000 
                      full_file_name  $ 3000
						transfer_to_site_in   send_received_cd 3
					   dir_nm $ 3000  dir_nm_sh $ 300 
				;
		  FORMAT  transfer_to_site_in 4.  send_received_cd 1.;

				dir_nm=STRIP(SYMGET("dir_nm")) ;
					  /*Defensive coding. Remove quotes if present*/
			IF         SUBSTR(dir_nm,1,1)=SUBSTR(dir_nm,LENGTH(dir_nm),LENGTH(dir_nm)) 
                AND SUBSTR(dir_nm,1,1) IN ("'",'"') 
			THEN  dir_nm=SUBSTR(dir_nm,2,LENGTH(dir_nm)-2);

			 IF    SUBSTR(dir_nm,LENGTH(dir_nm),LENGTH(dir_nm)) NOT IN ("/","\")
				 AND dir_nm NE " "
			 THEN  dir_nm=CATS(dir_nm,"/");

			dir_nm_sh=SCAN(STRIP(dir_nm),-1,"/\");

		  ARRAY tmp{2}  $ 32000 _TEMPORARY_ ("&tbl_list_to_transf. ", "&tbl_list_not_transf.")   ;
		  DO j=1 TO 2;
		     transfer_to_site_in=( j=1);
			tmp_str=STRIP(tmp{j});
		      count_tmp=COUNTW(STRIP(tmp_str), " ");			  
				DO i=1 TO count_tmp;
				  file_nm=SCAN(STRIP(tmp_str),i, " ");
				  tbl_name=SCAN(STRIP(file_nm),1, ".");
				  ext=SCAN(STRIP(file_nm),2, ".");
				  full_file_name=CATS(dir_nm,file_nm);
				 send_received_cd=&send_received_cd.;
				 OUTPUT;
			   END;
			END;
			     DROP i j tmp_str count_tmp;
		  RUN;

		   DATA   &file_list_tbl_out. ;
			 SET _file_list_tbl_out;

			   IF  transfer_to_site_in=0 THEN
				                              DO;
	        	IF           STRIP(LOWCASE(file_nm)) = "file_list.csv"  THEN transfer_to_site_in=10;
				ELSE IF STRIP(LOWCASE(file_nm)) = "job_done.ok"  THEN transfer_to_site_in=2;
				ELSE IF STRIP(LOWCASE(file_nm)) = "job_fail.ok"  THEN transfer_to_site_in=3;
											  END;
			RUN;

		%IF %LENGTH(&file_list_txt_out.) >0 %THEN
		               %DO;
		DATA  &file_list_tbl_out_for_csv.;
			SET &file_list_tbl_out.(KEEP=file_nm transfer_to_site_in);
			FORMAT transfer_to_site_in 4.;
		RUN;
 
		%export_sas_to_dlm_txt(tbl_name_in=&file_list_tbl_out_for_csv.
                                          ,file_name_out=&file_list_txt_out.);
						%END;

	%PUT;
   %PUT -----   Endt of the macro output_file_list;
   %PUT;

 	  OPTIONS &_DEBUG_OPTIONS_L.;

%MEND;	/* output_file_list*/