%LET dp_cd=0;
   
*%INCLUDE "J:\prshare\MSCDM\PRG\Mod_Prg_Physical_MSCDM\_Dev\Distributed_Regression\ver1\inputfiles\macros\parms_file.sas";

%LET sites_prg_root=%STR(F:\ASPE\Publications\Statistical Software Manuscripts\Testing Package 2019\Test 4\);
%INCLUDE "&sites_prg_root.parms_file2.sas";

  			   * END OF  HPHC TESTING/DEVELOPMENT SECTION ONLY;

**************************************************************************************************
*******                                  END OF USER INPUT                                  ******
*******                             DO NOT EDIT BELOW THIS LINE                             ******
*******                        (Consult with MSOC or MS team leader                         ******
*******                           if you feel edits are required)                           ******
**************************************************************************************************;

/*---------------------------------------------------------------------*/
/* NOTE: Programmer preparing Request-Id defines the                   */
/*       parameter MSReqID in coordination with the MSOC               */
/*---------------------------------------------------------------------*/

/*-------------------------------------------------------------------------------------------------
* Specific requests are made up a project-id, workplan-type, workplan-id, unique-dpid, version-id           
*--------------------------------------------------------------------------------------------------
*
*        If this is your request   . . . . .  then set parameter values as follows 
*   ---------------------------------     -------------------------------------------------------
*   [Task Order 7 - NME Dabigatran]       %let MSProjID = to07_nme_dabi ;  
*   [WorkPlan Type]                       %let MSWPType = ahr; 
*   [Workplan # 5]                        %let MSWPID = wp005 ; 
*   [Unique DP id]                        %let MSDPID = nsdp ;     
*   [Beta 3]                              %let MSVerID = b03 ;         
*   [use underscores as delimiter]        %let dlm = _ ;                
*
*   The example values above would produce a Request-Id equal to to07_nme_dabi_ahr_wp005_nsdp_b03
*
*--------------------------------------------------------------------------------------------------*/

* Specify project-id, workplan-type, worplan-id, and version-id *;
   /* Uncomment before sending to sites. The tags below are assigned by SOC*/
/*
%LET MSProjID = opi ;
%LET MSWPType = ahr;
%LET MSWPID = wp001 ;
%LET MSDPID = nsdp ;
%LET MSVerID = b01 ;
 
 %let dlm = _ ; 
 

* Request-Id *. 
 * MSReqID is expected by standard MSOC code below.;

 *%let MSReqID = &MSProjID.&dlm.&MSWPType.&dlm.&MSWPID.&dlm.&MSDPID.&dlm.&MSVerID ;
* Delete macro variable used as delimiter as we no longer need it *;
%symdel dlm ; 
  */


/* Request-Id/Workplan parameter value must be lower case */
%let MSReqID = %lowcase(&MSReqID) ;
*-------------------------------------------------------------------------------------------------
* 0- Setup Environment
*-------------------------------------------------------------------------------------------------;

/*---------------------------------------------------------------------*/
/* NOTE: This is standard MSOC environment setup code -- Do Not Edit   */
/*---------------------------------------------------------------------*/

/* System options */
 /*
options obs=MAX ;
options msglevel=i ;
options mprint mprintnest ;
options errorcheck=strict errors=0 ;
options merror serror ;
options dkricond=error dkrocond=error mergenoby=warn;
options dsoptions=nonote2err noquotelenmax ;
options reuse=no ;
options fullstimer ;
*/

options obs=MAX ;
options nosyntaxcheck ;
options merror serror ;
options dkricond=error dkrocond=error ;
options dsoptions=nonote2err noquotelenmax ;
options reuse=no ;
options mergenoby= nowarn ;

OPTIONS NOXWAIT NOXSYNC;

/*------------------------------------------------------------------------------------------------
* NOTES:
*   For reasons of compatibility and standardization, paths must meet the following criteria:
*     1- Starting with the workplan subdirectory, all subdirectory names must be specified in
*        lower case (for UNIX compatibility)
*     2- Slashes must be forward-leaning slashes '/' (for UNIX compatibility)
*     3- Paths must end with a final forward-leaning slash '/' (extra slashes are fine)
*------------------------------------------------------------------------------------------------*/


/* Define Workplan Specific Subdirectories */
%let DPLOCAL = &_root_dplocal.&MSReqID./dplocal/ ; 
%let MSOC = &_root_msoc.&MSReqID./msoc/ ;            
%let INFOLDER = &_root_inputfiles.&MSReqID./inputfiles/ ;  
%let SASPROGRAMS = &_root_sasprograms.&MSReqID./sasprograms/ ;
 
*For Testing; 
* %LET SASMACR=&mod_prg_root.inputfiles/macros/; 
/*For Production*/
%let SASMACR=&Infolder.macros/;

/* Assign libnames */
LIBNAME dplocal "&dplocal";
LIBNAME msoc "&msoc.";
LIBNAME infolder "&infolder.";

**************************************************************************************************
*******                                  BEGIN PROGRAM                                     *******
**************************************************************************************************;

/*---------------------------------------------------------------------*/
/* NOTE: Programmer preparing Workplan Request-ID includes/writes      */
/*       the rest of the program below                                 */
/*---------------------------------------------------------------------*/


  * Set up log file*;

  %LET prg_name_sh=&MSReqID.;

  %LET log_file=&msoc.&prg_name_sh..log;
  %LET lst_file=&msoc.&prg_name_sh..lst;
      /*For DP*/
  * %LET lst_file=&dplocal.&prg_name_sh..lst;
 %PUT "&log_file.";

  %PUT "&lst_file.";

 * Set up log and list file*;
  /*
 proc printto log= "&log_file." new PRINT="&lst_file." new;;
run ;
 */

* Include macros ;
  	/* General utility macros for DP's and central */
   %include "&sasmacr.ms_macros_v2.sas"; 
  %include "&sasmacr.ms_delpatients.sas"; 
  %include "&sasmacr.ms_time.sas";
  %include "&sasmacr.file_watcher.sas"; 
    %include "&sasmacr.check_var_list_in_tbl.sas";
    %include "&sasmacr.create_empty_file.sas"; 
   %include  "&sasmacr.delete_ext_file.sas" ;
   %include  "&sasmacr.delete_sas_tables.sas" ; 
   %include "&sasmacr.output_file_list.sas";
   %include "&sasmacr.find_files_mod_dtm.sas"; 
   %include "&sasmacr.calculate_sscp.sas";
   %include "&sasmacr.sum_by_pct2.sas";  
   %include "&sasmacr.export_sas_to_dlm_txt.sas";  
   %include "&sasmacr.import_dlm_txt_to_sas.sas";  
    %include "&sasmacr.modify_colnames.sas"; ; 

   					/*Central only utility macros */
   %include "&sasmacr.calc_matrix_product.sas";
   %include "&sasmacr.solve_linear_equations_reg.sas";
   %include "&sasmacr.lin_reg_with_sscp_input.sas";

				/*Distributed regression specific  central*/
	%include "&sasmacr.distributed_regression.sas"; 
	
   %include "&sasmacr.d_reg_central_step1_vglc.sas"; 
   %include "&sasmacr.d_reg_central_step2_vglc.sas"; 

   %include "&sasmacr.calc_genmod_iter_stats_central_v2.sas"; 
   %include "&sasmacr.calc_cox_iter_stats_central_vstr2_ef2.sas"; 
    %include "&sasmacr.check_track_convergence_vglc.sas"; 
   %include "&sasmacr.calc_cox_grad_hessian.sas";
   
  %include "&sasmacr.initialize_tracking_tbl.sas";   
   %include "&sasmacr.create_parameters_tbl.sas";
   %include "&sasmacr.update_tracking_tbl.sas"; 
   %include "&sasmacr.create_tracking_tbl_fl_lev_updt.sas"; 
   %include "&sasmacr.update_tracking_tbl_fl_lev.sas";    
   %include "&sasmacr.watch_dp_msoc.sas";   
   %include "&sasmacr.combine_dp_tbls.sas";
    %include "&sasmacr.cleanup_dp_msoc.sas";

   %include "&sasmacr.calc_final_stats_genmod_central.sas";
   %include "&sasmacr.calc_final_stats_cox_central_vstr2_ef2.sas";

   %include "&sasmacr.calc_hl_stats_central.sas"; 
   %include "&sasmacr.calc_hl_stats.sas"; 
	%include "&sasmacr.calc_roc.sas";
	%include "&sasmacr.create_status_time_rpt.sas";

	%include "&sasmacr.create_dir_structure_central.sas"; 
	%include "&sasmacr.create_dir_structure_sites_v2.sas";
   %include "&sasmacr._t_loop_through_dp.sas"; 
  
	%include "&sasmacr.create_lreg_rpt.sas";
    %include "&sasmacr.create_greg_rpt.sas"; 
	%include "&sasmacr.create_cox_reg_rpt.sas"; 
	%include "&sasmacr.chk_dir.sas";

*--------------------------------------------------------------------------------------------------
* 2- call macros
*--------------------------------------------------------------------------------------------------;
   /*
	OPTIONS MPRINT;
OPTIONS MLOGIC  ;
OPTIONS SYMBOLGEN;
 OPTIONS NOTES;
  */


%LET cntr_site_request_root=&central_site_prg_root.&MSReqID.&slash.;
%create_dir_structure_central(dp_cd_list=&dp_cd_list.,request_root=&cntr_site_request_root.);

*------------------------Distributed Linear------------------------------------------------------------------------;
/*
%LET RunID=dr1;

%LET reg_ds_in=boston_housing;
%LET  dependent_vars=medv;
%LET independent_vars=crim indus dis dummy_dp_var2 dummy_dp_var3;
%LET wait_time_max=7200; * 2 hrs;

%PUT  RunID=&RunID.;

%distributed_regression(RunID=&RunID.
					   ,reg_ds_in=&reg_ds_in. 
					   ,dependent_vars=&dependent_vars.
					   ,independent_vars=&independent_vars.
					   ,dp_cd_list=&dp_cd_list.
					   ,NOINT=
					   ,freq=
					   ,weight=
					   ,regr_type_cd=1
					   ,alpha=0.05
					   ,groups=10
					   ,wait_time_min=1
    				   ,wait_time_max=&wait_time_max.
					   ,test_env_cd=0
					  ,last_runid_in =1
						) ;
*/
*------------------------Distributed Logistic  min_count_per_grp_glob=6 ------------------------------------------------------------------------; 
/*
%LET RunID=dl16;

%LET tbl_intial_est=model_coeff_4 ;
%LET reg_ds_in=boston_housing;
%LET  dependent_vars=medv_high_flag;
%LET independent_vars=crim indus dis dummy_dp_var2 dummy_dp_var3;
%LET wait_time_max=7200;

%PUT  RunID=&RunID.;

%distributed_regression(RunID=&RunID.
					   ,reg_ds_in=&reg_ds_in. 
					   ,dependent_vars=&dependent_vars.
					   ,independent_vars=&independent_vars.
	                  ,dp_cd_list=&dp_cd_list.
					   ,NOINT=
					   ,freq=
					   ,weight=
					   ,regr_type_cd=2
	                   ,tbl_intial_est=&tbl_intial_est.
					   ,alpha=0.05
					  ,XCONV=1e-4
					   ,groups=10
					   ,wait_time_min=1
	    			   ,wait_time_max=&wait_time_max.
					   ,max_iter_nb=15
					   ,test_env_cd=0
					  ,last_runid_in =1
					  ,min_count_per_grp_glob=6
						) ;
*/	
*------------------------Distributed Cox  Regression ------------------------------------------------------------------------; 

%LET reg_ds_in=recid_dr;

%LET dependent_vars=week;
%LET independent_vars=fin age prio;
%LET censoring_var=arrest;
%LET censoring_lev=0;
%LET ties=BRESLOW;
*%LET ties=EFRON;

%LET RunID=dc3;
*%LET strata_vars=;
%LET strata_vars=dp_cd;
%LET tbl_intial_est=;
*%LET tbl_intial_est=Cox_Model_Coeff_ccs3_3;

%LET tbl_events_time_set=;

%LET xconv=1e-4;
%LET alpha=0.05;
%LET freq=;
%LET weight=;
%LET weight=weight2;

%PUT  RunID=&RunID.;

%distributed_regression(RunID=&RunID.
                       ,dp_cd_list=&dp_cd_list.
					   ,reg_ds_in=&reg_ds_in. 
					   ,dependent_vars=&dependent_vars.
					   ,independent_vars=&independent_vars.
					   ,censoring_var=&censoring_var.
					   ,censoring_lev=&censoring_lev.
					   ,strata_vars=&strata_vars.
					   ,ties=&ties.
					   ,NOINT=
					   ,freq=&freq.
					   ,weight=&weight.
					   ,regr_type_cd=10
					   ,tbl_intial_est=&tbl_intial_est.
					   ,tbl_events_time_set=&tbl_events_time_set.
					   ,alpha=0.05
					   ,groups=10
					   ,wait_time_min=3
    				  ,wait_time_max=300
					  ,last_runid_in =1
					  ,test_env_cd=0
					  ,max_iter_nb=10
					  ,XCONV=&xconv.
					  ,max_numb_of_grp=10000
					   ,min_count_per_grp_glob=6
						) ;
