		/* The parameter dp_cd (data partner code) for the central site should be always set to 0. Do not edit*/
 %LET dp_cd=0;

   /* Specify list of data partner codes participating in distributed regression*/
         %LET dp_cd_list=1 2 3;

 * Edit root directory for all requests related for distrubuted regression at the central site. ;

  * %LET sites_prg_root_dp=\distrib_regr_all_requests_central\;
 *%LET sites_prg_root_dp=J:\prshare\MSCDM\PRG\Mod_Prg_Physical_MSCDM\_Dev\Distributed_Regression\ver1\\dp_sites\dp0\;
 *%LET sites_prg_root_dp=%STR(J:\FDA_Sentinel_ASPE_2014\Internal testing\dp_sites\dp0\);
 %LET sites_prg_root_dp=J:\prshare\MSCDM\PRG\Mod_Prg_Physical_MSCDM\_Dev\Distributed_Regression\ver1\;

/* 
  Edit parameter MSReqID. Should be the same as name of the subdirectory for the request.
 *Use any name without spaces or special characters.  ;
*/
  
    *%LET MSReqID = request_1;
  %LET MSReqID = vglc1_t_mode_pack_01;

 *%LET MSReqID =vglc1_02_ln_lg;

   /* Edit directory which has the input regression dataset.
     Below is an example useful for testing. It refers to the subdirectory 
     within the same &MSReqID as the current request.

    For production it is likely to point to the sub-directory "dplocal" of the Sentinel request 
    which created analytic dataset. 
  */
 
* %LET data_in=J:\prshare\MSCDM\PRG\Mod_Prg_Physical_MSCDM\_Dev\Distributed_Regression\ver1\data_in;

   %LET data_in_dir=&sites_prg_root_dp.&MSReqID./data_in/;

	  /*	 Do not edit between this line and the line  "2- call macros". */
 
 %LET central_site_prg_root=&sites_prg_root_dp.;

/*---------------------------------------------------------------------*/
/* NOTE: Programmer preparing Request-Id defines the                   */
/*       parameter MSReqID in coordination with the Sentinel operation center (SOC)*/
/*---------------------------------------------------------------------*/
  
       *For testing use any name without spaces or special characters.  ;

 * %LET MSReqID =vglc1_02_ln_lg;


    /* For production Sentinel requests follow template below */

/*-------------------------------------------------------------------------------------------------
* Specific requests are made up a project-id, workplan-type, workplan-id, unique-dpid, version-id           
*--------------------------------------------------------------------------------------------------
*
*        If this is your request   . . . . .  then set parameter values as follows 
*   ---------------------------------     -------------------------------------------------------
*   [Task Order 7 - NME Dabigatran]       %let MSProjID = to07_nme_dabi ;  
*   [WorkPlan Type]                       %let MSWPType = ahr; 
*   [Workplan # 5]                        %let MSWPID = wp005 ; 
*   [Unique DP id]                        %let MSDPID = nsdp ;     
*   [Beta 3]                              %let MSVerID = b03 ;         
*   [use underscores as delimiter]        %let dlm = _ ;                
*
*   The example values above would produce a Request-Id equal to to07_nme_dabi_ahr_wp005_nsdp_b03
*
*--------------------------------------------------------------------------------------------------*/

* Specify project-id, workplan-type, worplan-id, and version-id *;
   /* Uncomment before sending to sites. The tags below are assigned by SOC*/
/*
%LET MSProjID = opi ;
%LET MSWPType = ahr;
%LET MSWPID = wp001 ;
%LET MSDPID = nsdp ;
%LET MSVerID = b01 ;
 
 %let dlm = _ ; 
 

* Request-Id *. 
 * MSReqID is expected by standard MSOC code below.;

 *%let MSReqID = &MSProjID.&dlm.&MSWPType.&dlm.&MSWPID.&dlm.&MSDPID.&dlm.&MSVerID ;
* Delete macro variable used as delimiter as we no longer need it *;
%symdel dlm ; 
  */

/* Request-Id/Workplan parameter value must be lower case */
%let MSReqID = %lowcase(&MSReqID) ;
*-------------------------------------------------------------------------------------------------
* 0- Setup Environment
*-------------------------------------------------------------------------------------------------;

/*---------------------------------------------------------------------*/
/* NOTE: This is standard environment setup code for distributed regression. -- Do Not Edit   */
/*---------------------------------------------------------------------*/

/* System options */

options obs=MAX ;
options nosyntaxcheck ;
options merror serror ;
options dkricond=error dkrocond=error ;
options dsoptions=nonote2err noquotelenmax ;
options reuse=no ;
options mergenoby= nowarn ;

OPTIONS NOXWAIT NOXSYNC;

/*------------------------------------------------------------------------------------------------
* NOTES:
*   For reasons of compatibility and standardization, paths must meet the following criteria:
*     1- Starting with the workplan subdirectory, all subdirectory names must be specified in
*        lower case (for UNIX compatibility)
*     2- Slashes must be forward-leaning slashes '/' (for UNIX compatibility)
*     3- Paths must end with a final forward-leaning slash '/' (extra slashes are fine)
*------------------------------------------------------------------------------------------------*/

 /*For test mode only*/
%LET data_in=&data_in_dir.;

/* Derive full path for standard Sentinel folders */
%let DPLOCAL = &sites_prg_root_dp.&MSReqID./dplocal/ ; 
%let MSOC = &sites_prg_root_dp.&MSReqID./msoc/ ;            
%let INFOLDER = &sites_prg_root_dp.&MSReqID./inputfiles/ ;  
%let SASPROGRAMS = &sites_prg_root_dp.&MSReqID./sasprograms/ ;
%let SASMACR=&Infolder.macros/;

/* Assign libnames */
LIBNAME dplocal "&dplocal";
LIBNAME msoc "&msoc.";
LIBNAME infolder "&infolder.";
LIBNAME data_in "&data_in_dir.";

**************************************************************************************************
*******                                  BEGIN PROGRAM                                     *******
**************************************************************************************************;

/*---------------------------------------------------------------------*/
/* NOTE: Programmer preparing Workplan Request-ID includes/writes      */
/*       the rest of the program below                                 */
/*---------------------------------------------------------------------*/


  * Set up log file*;

  %LET prg_name_sh=&MSReqID.;

  %LET log_file=&msoc.&prg_name_sh..log;
  %LET lst_file=&msoc.&prg_name_sh..lst;
      /*For DP*/
  * %LET lst_file=&dplocal.&prg_name_sh..lst;
 %PUT "&log_file.";
  %PUT "&lst_file.";

 * Set up log and list file*;
  /*
 proc printto log= "&log_file." new PRINT="&lst_file." new;;
run ;
 */

* Include macros ;
  						   /* General utility macros */
   %include "&sasmacr.ms_macros_v2.sas"; 
  %include "&sasmacr.ms_time.sas";
  %include "&sasmacr.file_watcher.sas"; 
    %include "&sasmacr.check_var_list_in_tbl.sas";
    %include "&sasmacr.create_empty_file.sas"; 
   %include  "&sasmacr.delete_ext_file.sas" ;
   %include  "&sasmacr.delete_sas_tables.sas" ; 
   %include "&sasmacr.output_file_list.sas";
   %include "&sasmacr.find_files_mod_dtm.sas"; 
   %include "&sasmacr.calculate_sscp.sas";
   %include "&sasmacr.sum_by_pct2.sas";  
   %include "&sasmacr.export_sas_to_dlm_txt.sas";  
   %include "&sasmacr.import_dlm_txt_to_sas.sas";  
    %include "&sasmacr.modify_colnames.sas"; 

     /*Distributed regression specific macros for central and  DP */
	  %include "&sasmacr.initialize_tracking_tbl.sas"; 
	   %include "&sasmacr.create_tracking_tbl_fl_lev_updt.sas"; 

   	  /*Distributed regression specific macros for DP */
   %include "&sasmacr.dp_main_vglc.sas"; 

     /* Genmod macros*/
   %include "&sasmacr.calc_genmod_iter_stats_dp.sas"; 
   %include "&sasmacr.calc_genmod_vars.sas"; 
   %include "&sasmacr.calc_residual_stats_genmod_dp.sas";

			   	/* Cox macros*/
	 %include "&sasmacr.calc_cox_iter_stats_dp_vstr2_ef2.sas";	 /* Add strata and move DP when dp_cd in strata */
	 %include "&sasmacr.calc_residual_stats_cox_dp_vstr2_ef2.sas";
 
					/*Central only utility macros */
   %include "&sasmacr.calc_matrix_product.sas";
   %include "&sasmacr.solve_linear_equations_reg.sas";
   %include "&sasmacr.lin_reg_with_sscp_input.sas";
    
				/*Distributed regression specific  central*/
	%include "&sasmacr.distributed_regression.sas"; 
   %include "&sasmacr.d_reg_central_step1_vglc.sas"; 
   %include "&sasmacr.d_reg_central_step2_vglc.sas"; 

   %include "&sasmacr.calc_genmod_iter_stats_central_v2.sas"; 

   %include "&sasmacr.calc_cox_iter_stats_central_vstr2_ef2.sas"; /* Add strata and move DP when dp_cd in strata */
    %include "&sasmacr.check_track_convergence_vglc.sas"; /* Add strata and move DP when dp_cd in strata */
   %include "&sasmacr.calc_cox_grad_hessian.sas";
   
  %include "&sasmacr.initialize_tracking_tbl.sas";   
   %include "&sasmacr.create_parameters_tbl.sas";
   %include "&sasmacr.update_tracking_tbl.sas"; 
   %include "&sasmacr.update_tracking_tbl_fl_lev.sas";    
   %include "&sasmacr.watch_dp_msoc.sas";   
   %include "&sasmacr.combine_dp_tbls.sas";
    %include "&sasmacr.cleanup_dp_msoc.sas";

   %include "&sasmacr.check_track_convergence_vglc.sas";
	 %include "&sasmacr.calc_final_stats_genmod_central.sas"; 	
	  %include "&sasmacr.calc_final_stats_cox_central_vstr2_ef2.sas";

   %include "&sasmacr.calc_hl_stats_central.sas"; 
   %include "&sasmacr.calc_hl_stats.sas"; 
	%include "&sasmacr.calc_roc.sas";
	%include "&sasmacr.create_status_time_rpt.sas";

	   		 /*Distributed regression specific  for development and testing only*/
    %include "&sasmacr._t_loop_through_dp.sas";   
	%include "&sasmacr.create_dir_structure_central.sas"; 
	%include "&sasmacr.create_dir_structure_sites_v2.sas";
	* %include "&sasmacr.lin_reg_with_data_input.sas";
   * %include "&sasmacr.logit_reg_with_data_input.sas";
*	%include "&sasmacr.cox_reg_with_data_input.sas";
    %include "&sasmacr.create_greg_rpt.sas";
	%include "&sasmacr.create_cox_reg_rpt.sas";

 *--------------------------------------------------------------------------------------------------
* 2- call macros
*--------------------------------------------------------------------------------------------------;

/*The macro below create msocN subfolders for DPs listed in dp_cd_list (if they don't exist). 
              The value of N is determined by the actual value of the dp_cd, and NOT by its position in the list. 
              The macro also define global macro variables &msocN which store the full path for these directories and
              assigns SAS libraries msocN associated with above directories. 
	  */


	   %LET cntr_site_request_root=&central_site_prg_root.&MSReqID./;
		 %create_dir_structure_central(dp_cd_list=&dp_cd_list.,request_root=&cntr_site_request_root.);


			
 	    *------------------------Distributed Linear------------------------------------------------------------------------;

					%LET RunID=dr1;
				*	%LET tbl_intial_est=Model_Coeff_4 ;
			 
					%LET reg_ds_in=LINEAR_KARR_2005;
					%LET  dependent_vars=medv;
					%LET independent_vars=crim indus dis dummy_dp_var2 dummy_dp_var3;

					%PUT  RunID=&RunID.;

	%distributed_regression(RunID=&RunID.
											   ,reg_ds_in=&reg_ds_in. 
											   ,dependent_vars=&dependent_vars.
											   ,independent_vars=&independent_vars.
											   ,dp_cd_list=1 2 3
											   ,NOINT=
											   ,freq=
											   ,weight=
											   ,regr_type_cd=1
											   ,alpha=0.05
											   ,groups=10
											   ,wait_time_min=1
	    									   ,wait_time_max=30
											   ,test_env_cd=1
											  ,last_runid_in =1
												) 
                                  ;

	   		
			 %create_greg_rpt( lib_in=msoc
                                   ,rpt_dir_out=&dplocal.
                                   ,prefix_r=&RunID._
                                   ,regr_type_cd=1
                                   ,distributed_reg_in=1
								   ,pdf_style=JOURNAL2
								    ,rpt_format=rtf
								     );

									 
	 *------------------------Distributed Logistic  min_count_per_grp_glob=6 ------------------------------------------------------------------------; 
				 
					%LET RunID=dl16;
					%LET tbl_intial_est=model_coeff_0 ;
			 
					%LET reg_ds_in=LINEAR_KARR_2005;
					%LET  dependent_vars=medv_high_flag;
					%LET independent_vars=crim indus dis dummy_dp_var2 dummy_dp_var3;

					%PUT  RunID=&RunID.;

	 					 %distributed_regression(RunID=&RunID.
											   ,reg_ds_in=&reg_ds_in. 
											   ,dependent_vars=&dependent_vars.
											   ,independent_vars=&independent_vars.
											   ,dp_cd_list=1 2 3
											   ,NOINT=
											   ,freq=FREQ1
											   ,weight=
											   ,regr_type_cd=2
											   ,tbl_intial_est=&tbl_intial_est.
											   ,alpha=0.05
											  ,XCONV=1e-4
											   ,groups=10
											   ,wait_time_min=1
	    									   ,wait_time_max=30
											   ,max_iter_nb=10
											   ,test_env_cd=1
											  ,min_count_per_grp_glob=6
												) 
                                  ;
			
			 %create_greg_rpt( lib_in=msoc
                                   ,rpt_dir_out=&dplocal.
                                   ,prefix_r=&RunID._
                                   ,regr_type_cd=2
                                   ,distributed_reg_in=1
								   ,pdf_style=JOURNAL2
								    ,rpt_format=rtf
								     );


				   /* Distributed Breslow, no strata */					

		
					%distributed_regression(RunID=dc1
					                                           ,dp_cd_list=1 2 3
															   ,reg_ds_in=RECID_DR
															   ,dependent_vars=week
															   ,independent_vars=fin age  prio
															   ,censoring_var=arrest
															   ,regr_type_cd=10
															   ,tbl_intial_est=Cox_Model_Coeff_0
															   ,tbl_events_time_set=RECID_Events_Time_Set
															  ,xconv=1e-4
															   ,test_env_cd=1
																) ;		   
		 
            %LET prefix_c=dc1_; 
		   %PUT prefix_c=&prefix_c.;

	   %create_cox_reg_rpt( lib_in=msoc
                                            ,rpt_dir_out=&dplocal.
                                             ,prefix_r=&prefix_c.
                                            ,distributed_reg_in=1
									         ,pdf_style=JOURNAL						
								             ,rpt_format=rtf
									        ,format_N=D12.4
                                             );



							/* Distributed Effron, no strata_vars=dp_cd
							   In previous test we used  RunID=dc2 for this test case*/	
 
					%distributed_regression(RunID=dc2
					                                           ,dp_cd_list=1 2 3
															   ,reg_ds_in=RECID_DR
															   ,dependent_vars=week
															   ,independent_vars=fin age  prio
															   ,censoring_var=arrest
															   ,strata_vars=dp_cd
															   ,ties=EFRON
															   ,regr_type_cd=10
															   ,tbl_intial_est=COX_MODEL_COEFF_0
															   ,test_env_cd=1
																) ;
		   
		 
            %LET prefix_c=dc2_; 
		   %PUT prefix_c=&prefix_c.;

		   %create_cox_reg_rpt( lib_in=msoc
                                            ,rpt_dir_out=&dplocal.
											,strata_vars=dp_cd
                                             ,prefix_r=&prefix_c.
                                            ,distributed_reg_in=1
									         ,pdf_style=JOURNAL2						
								             ,rpt_format=rtf
									         ,format_N=D12.4
                                             );
	