%LET dp_cd=0;
 
* %INCLUDE "J:\prshare\MSCDM\PRG\Mod_Prg_Physical_MSCDM\_Dev\Distributed_Regression\ver1\inputfiles\macros\parms_file.sas";

%LET sites_prg_root=%STR(F:\ASPE\Publications\Statistical Software Manuscripts\Testing Package 2019\Test 2\);
%INCLUDE "&sites_prg_root.parms_file2.sas";

options obs=MAX ;
options nosyntaxcheck ;
options merror serror ;
options dkricond=error dkrocond=error mergenoby=warn;
options dsoptions=nonote2err noquotelenmax ;
options reuse=no ;

OPTIONS NOXWAIT NOXSYNC;

/*------------------------------------------------------------------------------------------------
* NOTES:
*   For reasons of compatibility and standardization, paths must meet the following criteria:
*     1- Starting with the workplan subdirectory, all subdirectory names must be specified in
*        lower case (for UNIX compatibility)
*     2- Slashes must be forward-leaning slashes '/' (for UNIX compatibility)
*     3- Paths must end with a final forward-leaning slash '/' (extra slashes are fine)
*------------------------------------------------------------------------------------------------*/

/* Request-Id/Workplan parameter value must be lower case */


/* Define Workplan Specific Subdirectories */
%let DPLOCAL = &_root_dplocal.&MSReqID.&slash.dplocal&slash. ; 
%let MSOC = &_root_msoc.&MSReqID.&slash.msoc&slash. ;            
%let INFOLDER = &_root_inputfiles.&MSReqID.&slash.inputfiles&slash. ;  
%let SASPROGRAMS = &_root_sasprograms.&MSReqID.&slash.sasprograms&slash. ;

*For Testing; 
*%LET SASMACR=&mod_prg_root.inputfiles&slash.macros&slash.; 
/*For Production*/
%let SASMACR=&infolder.macros/;

/* Assign libnames */
LIBNAME dplocal "&DPLOCAL";
LIBNAME msoc "&msoc.";
LIBNAME infolder "&infolder.";

**************************************************************************************************
*******                                  BEGIN PROGRAM                                     *******
**************************************************************************************************;

/*---------------------------------------------------------------------*/
/* NOTE: Programmer preparing Workplan Request-ID includes/writes      */
/*       the rest of the program below                                 */
/*---------------------------------------------------------------------*/


  * Set up log file*;

  %LET prg_name_sh=mv_file_&MSReqID.;

   %LET log_file=&msoc.&prg_name_sh..log;
  %LET lst_file=&msoc.&prg_name_sh..lst;
      /*For DP*/
  * %LET lst_file=&dplocal.&prg_name_sh..lst;
 %PUT "&log_file.";

  %PUT "&lst_file.";

 * Set up log and list file*;
  /*
 proc printto log= "&log_file." new PRINT="&lst_file." new;;
run ;
 */

* Include macros ;
   %include "&sasmacr.ms_macros_v2.sas"; 
  %include "&sasmacr.ms_time.sas";
  %include "&sasmacr.file_watcher.sas"; 
    %include "&sasmacr.create_empty_file.sas"; 
   %include  "&sasmacr.delete_ext_file.sas" ;
   %include  "&sasmacr.delete_sas_tables.sas" ; 
   %include "&sasmacr.output_file_list.sas";
   %include "&sasmacr.find_files_mod_dtm.sas"; 
   %include "&sasmacr.export_sas_to_dlm_txt.sas";  
   %include "&sasmacr.import_dlm_txt_to_sas.sas"; 

    %include  "&sasmacr.copy_sas_tables.sas" ;  
   %include  "&sasmacr.copy_ext_files.sas" ; 
	%include "&sasmacr.create_dir_structure_central.sas"; 
	%include "&sasmacr.create_dir_structure_sites_v2.sas";
	%include "&sasmacr.mv_files_between_central_dp.sas"; 
	%include "&sasmacr.chk_dir.sas";

*--------------------------------------------------------------------------------------------------;
* 2- call macros
*--------------------------------------------------------------------------------------------------;



	%LET std_dir_list=data_in dplocal msoc inputfiles  sasprograms;

     %create_dir_structure_sites(dp_cd_list=0 &dp_cd_list. 
													     ,std_dir_list=&std_dir_list.
													     ,sites_prg_root=&sites_prg_root.
														 ,MSReqID=&MSReqID.
                                                         );

	 %LET cntr_site_request_root=&central_site_prg_root.&MSReqID.&slash.;
	 %create_dir_structure_central(dp_cd_list=&dp_cd_list.,request_root=&cntr_site_request_root.);

	  %mv_files_between_central_dp(dp_cd_list=&dp_cd_list., max_run_time_in_sec=&max_run_time_in_sec. );

