 %MACRO import_dlm_txt_to_sas(file_name_in=
                                                       ,tbl_name_out=
                                                      ,File_type=CSV
													  ,delimiter=
                                                      ,Col_in_fst_row=Y
													  ,guessingrows=32767
													  )	;

	/*
   Usage:

	%LET msoc_lib=msoc1;
   %LET msoc_dir=&msoc1;
   %LET prefix=dr2_i1_;


 %import_dlm_txt_to_sas(file_name_in=&msoc_dir.&prefix.tr_tb_updt.csv
                                      ,tbl_name_out=tr_tb_updt_t
										)	;

%import_dlm_txt_to_sas(file_name_in=&msoc_dir.&prefix.tr_tb_updt_t.txt
                                      ,tbl_name_out=tr_tb_updt_t
									  ,File_type=dlm
									  ,delimiter="&"
                                      ,Col_in_fst_row=Y
										)	;

*/

	%GLOBAL m_return_cd   DEBUG_FLAG2 ;	
 
 %LOCAL _DEBUG_OPTIONS_L str_delimiter str_getnames;

 %LET m_return_cd=0;

 %LET _DEBUG_OPTIONS_L=%sysfunc(getoption(symbolgen)) %sysfunc(getoption(mprint)) %sysfunc(getoption(mlogic)) %sysfunc(getoption(notes)) %sysfunc(getoption(source)) %sysfunc(getoption(source2));
	
 %IF &DEBUG_FLAG2. NE Y %THEN %DO;OPTIONS NOMLOGIC NOMPRINT NOSYMBOLGEN NONOTES NOSOURCE NOSOURCE2; %END;

  %PUT;
   %PUT -----   Start of the macro import_dlm_txt_to_sas. ;
   %PUT;

   %IF %LENGTH(&File_type.)=0 %THEN %LET File_type=dlm;
   %IF %LENGTH(&delimiter.)=0           %THEN %LET delimiter=" ";

   %IF %lowcase(&File_type.)=dlm %THEN %LET str_delimiter=%STR(DELIMITER=&delimiter.);
   %ELSE %LET str_delimiter=;

    %IF %lowcase(&File_type.) NE jmp %THEN %LET str_getnames=%STR(getnames=&Col_in_fst_row.);
   %ELSE %LET str_getnames=;
 
PROC IMPORT DATAFILE="&file_name_in."  REPLACE
     OUT=&tbl_name_out.
     DBMS=&File_type.
   ;
	 &str_delimiter.; 
	 &str_getnames.;
	 GUESSINGROWS=&guessingrows. ;
RUN;

%LET m_return_cd=&syserr.;

%IF &m_return_cd. NE 0 %THEN
        %DO;
  %PUT m_return_cd=&m_return_cd. ;  
        %END;

  %PUT;
   %PUT -----   End of the macro import_dlm_txt_to_sas.  ;
   %PUT;

  OPTIONS &_DEBUG_OPTIONS_L.;
%MEND;


   